%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
-module(eva_log_sup).
-author('mbj@erlang.ericsson.se').
-copyright('Copyright (c) 1991-97 Ericsson Telecom AB').
-vsn('$Revision: /main/release/free/1').

-behaviour(supervisor).

-define(LogServer, {log_server,
		    {log_server, start_link, []},
		    permanent, 2000, worker, [log_server]}).

-define(LogSnmp, {log_snmp,
		  {log_snmp, start_link, []},
		  permanent, 2000, worker, [log_snmp]}).

%% External exports
-export([start_link/1, start_link/3]).

%% Internal exports
-export([init/1]).

%%-----------------------------------------------------------------
%% Convinent supervisor to use for LOG, with or without snmp
%% implementation.
%%-----------------------------------------------------------------
start_link(DefaultLog) ->
    supervisor:start_link({local, eva_log_sup}, ?MODULE, DefaultLog).
start_link(DefaultLog, LogDir, MaxDirSize) ->
    supervisor:start_link({local, eva_log_sup}, ?MODULE,
			  {DefaultLog, LogDir, MaxDirSize}).

init({DefaultLog, LogDir, MaxDirSize}) ->
    SupFlags = {rest_for_one, 4, 3600},
    EvaLogH = {eva_log_h_sup,
	       {eva_log, start_link, [DefaultLog]},
	       permanent, 2000, worker, [eva_log]},
    EvaLogSnmp = {eva_log_snmp,
		  {eva_log_snmp, start_link, [LogDir, MaxDirSize]},
		  permanent, 2000, worker, [eva_log_snmp]},
    {ok, {SupFlags, [?LogServer, EvaLogH, ?LogSnmp, EvaLogSnmp]}};

init(DefaultLog) ->
    SupFlags = {rest_for_one, 4, 3600},
    EvaLogH = {eva_log_h_sup,
	       {eva_log, start_link, [DefaultLog]},
	       permanent, 2000, worker, [eva_log]},
    {ok, {SupFlags, [?LogServer, EvaLogH]}}.
