%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%%%----------------------------------------------------------------------
%%% File    : setup.erl
%%% Author  : Dan Gudmundsson <dgud@erix.ericsson.se>
%%% Purpose : Initilize the mnesia__corba_session application in erlang
%%% Created : 28 Apr 1998 by Dan Gudmundsson <dgud@erix.ericsson.se>
%%%----------------------------------------------------------------------

-module(setup).
-author('dgud@erix.ericsson.se').

-export([start_apps/1, go/0]).

go() ->
    Ns = [node()],
    start_apps(Ns).

%% Start the needed applications mnesia, orber and mnesia_corba_session.
start_apps(Ns) ->    
    %% We don't really need to start mnesia here, it can be done through the intf.
    [rpc:call(Node, mnesia, start, []) || Node <- Ns],
    mnesia_session_lib:start([]).

