%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%%-----------------------------------------------------------------
%% File: naming_context.erl
%% Author: Lars Thorsen
%% 
%% Creation date: 970902
%% Modified:
%%
%%-----------------------------------------------------------------
-module('CosNaming_BindingIterator_impl').
-include_lib("orber/include/corba.hrl").

%%-----------------------------------------------------------------
%% External exports
%%-----------------------------------------------------------------
-export([init/1, terminate/2]).
-export([next_one/1, next_n/2, destroy/1]).

%%-----------------------------------------------------------------
%% Internal exports
%%-----------------------------------------------------------------
-export([]).

%%-----------------------------------------------------------------
%% Macros
%%-----------------------------------------------------------------
%%-----------------------------------------------------------------
%% External interface functions
%%-----------------------------------------------------------------
%%-----------------------------------------------------------------
%% Func: init/1
%% Args:
%% Returns: 
%%-----------------------------------------------------------------
init(BList) ->
    {ok, BList}.

%%-----------------------------------------------------------------
%% Func: terminate/2
%% Args:
%% Returns: 
%%-----------------------------------------------------------------
terminate(Reason, State) ->
    ok.

next_one([]) ->
    {{false, null}, []};
next_one([H|T]) ->
    {{true, H}, T}.

next_n(How_many, []) ->
    {false, [], []};
next_n(How_many, BList) ->
    RetBList = lists:sublist(BList, How_many),
    case catch lists:nthtail(How_many, BList) of
	{'EXIT', _} ->
	    {{false, RetBList}, []};
	NewBList ->
	    case NewBList of
		0 ->
		    {{false, RetBList}, NewBList};
		_ ->
		    {{true, RetBList}, NewBList}
	    end
    end.

destroy(OE_State) ->
    %% Objkey server removes objectkey when receiving EXIT signal.
    {stop, normal, ok, OE_State}.
%%-----------------------------------------------------------------
%% Internal functions
%%-----------------------------------------------------------------
%%-----------------------------------------------------------------
%% Func: 
%% Args:
%% Returns: 
%%-----------------------------------------------------------------
