%%--------------------------------------------------------------------
%%
%%    COPYRIGHT Ericsson Telecom AB 1998
%%
%%    126 25 STOCKHOLM
%%    SWEDEN
%%    tel int + 46 8 719 0000
%%
%%    The copyright to the computer program herein is the property of
%%    Ericsson Telecom AB, Sweden. The program may be used and/or
%%    copied only with the written permission from Ericsson Telecom AB
%%    or in accordance with the terms and conditions stipulated in the
%%    agreement/contract under which the program have been supplied.
%%
%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%%-----------------------------------------------------------------
%% File: any.erl
%% Author: Lars Thorsen
%% 
%% Description:
%%    This file conatins the interface for the any type
%%
%% Creation date: 980410
%%
%%-----------------------------------------------------------------
-module(any).
-copyright('Copyright (c) 1991-98 Ericsson Telecom AB').
-author('lars@erix.ericsson.se').

-include_lib("orber/include/corba.hrl").

%%-----------------------------------------------------------------
%% External exports
%%-----------------------------------------------------------------
-export([create/0, create/2,
	 set_typecode/2, get_typecode/1,
	 set_value/2, get_value/1]).

%%-----------------------------------------------------------------
%% Internal exports
%%-----------------------------------------------------------------
-export([]).

%%-----------------------------------------------------------------
%% External functions
%%-----------------------------------------------------------------
create() ->
    #any{}.

create(TC, V) ->
    case orber_tc:check_tc(TC) of
	true ->
	    #any{typecode=TC, value=V};
	false ->
	    {error, bad_typecode}
    end.


set_typecode(Any, TC) ->
    case orber_tc:check_tc(TC) of
	true ->
	    #any{typecode=TC};
	false ->
	    {error, bad_typecode}
    end.

get_typecode(Any) ->
    #any.typecode.


set_value(Any, V) ->
     #any{value=V}.

get_value(Any) ->
    #any.value.
