%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%%%----------------------------------------------------------------------
%%% File    : orber_ifr_idltype.erl
%%% Author  : Per Danielsson <pd@gwaihir>
%%% Purpose : Code for Idltype
%%% Created : 14 May 1997 by Per Danielsson <pd@gwaihir>
%%%----------------------------------------------------------------------

-module(orber_ifr_idltype).
-author('pd@gwaihir').

%%-compile(export_all).
-export(['_get_def_kind'/1,
	 destroy/1,
	 cleanup_for_destroy/1,			%not in CORBA 2.0
	 '_get_type'/1
	]).

-import(orber_ifr_utils,[get_field/2]).

-include("orber_ifr.hrl").
%-include_lib("mnesia/include/mnemosyne.hrl").
-include("ifr_objects.hrl").
%-include_lib("orber/include/ifr_types.hrl").

%%%======================================================================
%%% IDLType (IRObject)

%%%----------------------------------------------------------------------
%%% Interfaces inherited from IRObject

'_get_def_kind'({ObjType, ObjID}) ?tcheck(ir_IDLType, ObjType) ->
    orber_ifr_irobject:'_get_def_kind'({ObjType, ObjID}).

%%% Don't type check the object reference. We need to be able to
%%% handle several types of objects that inherit from IDLType.

destroy(IDLType_objref) ->
    F = fun() -> ObjList = cleanup_for_destroy(IDLType_objref),
		 orber_ifr_irobject:destroy(ObjList)
	end,
    orber_ifr_utils:ifr_transaction_write(F).

cleanup_for_destroy(IDLType_objref) ->
    [IDLType_objref].

%%%----------------------------------------------------------------------
%%% Non-inherited interfaces

%% What is this ? You cannot check this for ir_IDLType here !
%% ( an object type cannot be both .... ) 
%%'_get_type'({ObjType,ObjID}) ?tcheck(ir_IDLType, ObjType) ->
%%    get_field({ObjType,ObjID},type).


'_get_type'({ObjType,ObjID}) ->
    get_field({ObjType,ObjID},type).
