%%--------------------------------------------------------------------
%%
%%    COPYRIGHT Ericsson Telecom AB 1998
%%
%%    126 25 STOCKHOLM
%%    SWEDEN
%%    tel int + 46 8 719 0000
%%
%%    The copyright to the computer program herein is the property of
%%    Ericsson Telecom AB, Sweden. The program may be used and/or
%%    copied only with the written permission from Ericsson Telecom AB
%%    or in accordance with the terms and conditions stipulated in the
%%    agreement/contract under which the program have been supplied.
%%
%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.0, (the "License"); you may not use this file except in
%% compliance with the License. You may obtain a copy of the License at
%% http://www.erlang.org/EPL1_0.txt
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Original Code is Erlang-4.7.3, December, 1998.
%% 
%% The Initial Developer of the Original Code is Ericsson Telecom
%% AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
%% Telecom AB. All Rights Reserved.
%% 
%% Contributor(s): ______________________________________.''
%%
%%-----------------------------------------------------------------
%% File: orber_request_number.erl
%% Author: Lars Thorsen
%% 
%% Description:
%%    This file contains the request number server in Orber
%%
%% Creation date: 970917
%% 
%%-----------------------------------------------------------------
-module(orber_request_number).
-copyright('Copyright (c) 1991-98 Ericsson Telecom AB').
-author('lars@erix.ericsson.se').

-behaviour(gen_server).

%%-----------------------------------------------------------------
%% External exports
%%-----------------------------------------------------------------
-export([start/1, get/0, reset/0]).

%%-----------------------------------------------------------------
%% Internal exports
%%-----------------------------------------------------------------
-export([init/1, terminate/2, handle_call/3]).
-export([handle_cast/2, handle_info/2]).

%%-----------------------------------------------------------------
%% External interface functions
%%-----------------------------------------------------------------
start(Opts) ->
    gen_server:start_link({local, orber_reqno}, orber_request_number, Opts, []).

get() ->
    gen_server:call(orber_reqno, get, infinity).

reset() ->
    gen_server:reset(orber_reqno, reset, infinity).

%%-----------------------------------------------------------------
%% Server functions
%%-----------------------------------------------------------------
init(Opts) ->
    {ok, 0}.

terminate(Reason, State) ->
	    ok.

handle_call(get, From, State) ->
    {reply, State, State+1};
handle_call(reset, From, State) ->
    {reply, ok, 0}.

handle_cast(_, State) ->
    {noreply,  State}.

handle_info(_, State) ->
    {noreply,  State}.

